## dasm 2.20.15~20201012+git283e30d

=== src/Makefile ===
#
# the DASM macro assembler (aka small systems cross assembler)
#
# Copyright (c) 1988-2002 by Matthew Dillon.
# Copyright (c) 1995 by Olaf "Rhialto" Seibert.
# Copyright (c) 2003-2008 by Andrew Davie.
# Copyright (c) 2008 by Peter H. Froehlich.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Executables will be generated in the trunk/src/ directory (the
# "current directory" as far as this Makefile is concerned). If
# you want to move them somewhere, trunk/bin/ say, do so in the
# trunk/ Makefile!


#GOPTI= -O -m32 # -O for more warnings; use -O0 for debugging, use -O3 for speed

GWARN= -ansi -std=c99 -pedantic -Wall \
       -Wstrict-prototypes -Wdeclaration-after-statement \
       -Wold-style-definition -Wmissing-declarations -Wmissing-prototypes \
       -Wshadow -Wwrite-strings -Wcast-qual -Wnested-externs \
       -Wcast-align -Wpointer-arith -Wbad-function-cast \
       -Wformat-y2k -Wformat-nonliteral -Wformat-security \
       -Wfloat-equal -Wundef -Winline \
       # -Wfour-char-constants # Apple OS X only option, not needed anyway?
       # -Wunused # definition is weird in man gcc, effect is weird too
       # -Wextra -Wno-unused-parameter # no-unused tames extra a little
       # -Wunreachable-code # seems to create 4 spurious warnings?
       # -Wconversion # too many right now
       # -Wtraditional # too many, not sure if it's worth it anyway

#GDEBG= -g # -fprofile-arcs -ftest-coverage -pg # -D_FORTIFY_SOURCE=2

#CFLAGS= $(GOPTI) $(GWARN) $(GDEBG)
#LDFLAGS= -m32 -L/usr/lib32

#CC= gcc

OBJS= main.o ops.o globals.o exp.o symbols.o \
      mne6303.o mne6502.o mne68705.o mne6811.o mnef8.o mne68908.o
SRCS= main.c ops.c globals.c exp.c symbols.c \
      mne6303.c mne6502.c mne68705.c mne6811.c mnef8.c mne68908.c

ALL= dasm ftohex

all: $(ALL)

dasm: $(OBJS)
	$(CC) $(OBJS) -o dasm $(LDFLAGS)

ftohex: ftohex.o

obj: $(OBJS)

$(OBJS): asm.h

clean:
	rm -rf *.o $(ALL) \
	dasm-alpha-*.tar.gz \
	*.gcda *.gcno *.gcov gmon.out

# prepare an alpha release containing just the source code,
# nothing else is in the archive since it is not intended
# for the public, just designated volunteers

alpha:
	echo "This is an incomplete alpha release of DASM source code." >README.ALPHA
	echo "The purpose is to identify build problems, nothing more." >>README.ALPHA
	echo "Please do *not* re-distribute this release in any form!" >>README.ALPHA
	echo "Please do *not* distribute binaries derived from it either!" >>README.ALPHA
	tar zcvf dasm-alpha-`date +%F`.tar.gz README.ALPHA Makefile *.h *.c
	rm -rf README.ALPHA

=== debian/changelog ===
dasm (2.20.15~20201012+git283e30d-1) unstable; urgency=medium

  * Initial release, Closes: #971885.
  * [d3fe00c] add manpage for dasm
  * [f045bb1] use salsa-ci pipeline
  * [11b8401] disable test-build-all job in salsa-ci
  * [76f40a0] enable diffoscope for reprotest
  * [f7b5dd6] force source date to date of last doc source commit
  * [9ae0e57] add lintian overrides

 -- Joseph Nahmias <jello@debian.org>  Thu, 15 Oct 2020 21:09:02 -0400

## dasm 2.20.15~20201109%2Breally2.20.14.1

=== debian/changelog ===
dasm (2.20.15~20201109+really2.20.14.1-3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Fri, 06 Feb 2026 21:12:44 +0100

dasm (2.20.15~20201109+really2.20.14.1-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing
    See-also: https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    See-also: https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html
  * Update lintian override info format in d/source/lintian-overrides on line 5.
    Changes-By: lintian-brush
    Fixes: lintian: mismatched-override
    See-also: https://lintian.debian.org/tags/mismatched-override.html

  [ Joe Nahmias ]
  * drop unnecessary lintian override
  * enable extra build jobs in salsa ci
  * run wrap-and-sort -asbkt; enable corresponding job in salsa ci

  [ Sergio Durigan Junior ]
  * Fix FTBFS with GCC 15.
    Thanks to Sergio Durigan Junior <sergiodj@debian.org> (Closes: #1096503)

 -- Joseph Nahmias <jello@debian.org>  Sat, 27 Sep 2025 21:52:19 -0400

dasm (2.20.15~20201109+really2.20.14.1-2) unstable; urgency=medium

  * [00c6200] bump std-ver to 4.6.1; no changes
  * [bbd9157] convert to new lintian override format
  * [abd5a78] bump copyright year

 -- Joseph Nahmias <jello@debian.org>  Thu, 27 Oct 2022 00:05:37 -0400

dasm (2.20.15~20201109+really2.20.14.1-1) unstable; urgency=medium

  * [83421eb] New upstream version 2.20.14.1
  * [21d7179] fix upstream tag format
  * [ac78f02] drop local dasm manpage, merged upstream

 -- Joseph Nahmias <jello@debian.org>  Wed, 11 Nov 2020 00:13:58 -0500

## dasm 2.20.15~20201109+really2.20.14.1

=== Makefile ===
#
# the DASM macro assembler (aka small systems cross assembler)
#
# Copyright (c) 1988-2002 by Matthew Dillon.
# Copyright (c) 1995 by Olaf "Rhialto" Seibert.
# Copyright (c) 2003-2008 by Andrew Davie.
# Copyright (c) 2008 by Peter H. Froehlich.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Simple hack to build everything, test everything, make a beta
# distribution, or make a real distribution. Default is to just
# build everything. Installation is not implemented yet.

# TODO: need to do documentation stuff as well; don't forget to
# delete automatically generated documentation in clean: below

# just an alias for build really...
all: build
	echo "Build complete, use 'make test' to run tests."

# install, currently not implemented
install: build
	echo "Installation not implemented, you're on your own, sorry."

# just run all the tests
test: build
	@echo "Running tests..."
	(cd test; $(MAKE); cd ..)
	@echo "Tests were run, but testing is not fully automated yet."
	@echo "In other words, don't rely on what you saw too much."

# just build everything and copy binaries to trunk/bin/
build:
	(cd src; $(MAKE); cd ..)
	mkdir -p bin
	cp src/dasm bin/dasm
	cp src/ftohex bin/ftohex

# release version to use for archive name
# supply this to make when you run it as
#   RELEASE=2.20.12
# on the command line, that's the easiest
# thing to do
RELEASE=unknown-version-number
# architecture for including binaries/executables
# supply this to make when you run it as
#   BINARY=osx-ppc  or  BINARY=beos-x86  or  ...
# on the command line, that's the easiest
# thing to do; note that this only affects
# the name of the archive, the binaries
# are always put into a trunk/bin folder
# if left empty, source distribution is assumed...
BINARY=

# binaries
BINS=bin/*
# documentation
DOCS=AUTHORS ChangeLog LICENSE CREDITS NEWS README  doc/*
# support files for various machines
MACS=machines/atari2600/* machines/channel-f/*
# source files for dasm and ftohex
SRCS=src/*.h src/*.c src/Makefile # src/TODO? src/HEADER? src/PATCHES?
# test files for dasm and ftohex
TSTS=test/*.asm test/*.bin.ref test/*.hex.ref test/Makefile test/run_tests.sh test/atari2600/Makefile test/atari2600/README test/atari2600/*.asm test/atari2600/*.ref
# other files
OTHS=Makefile

ifeq ($(strip $(BINARY)),)
# source release, no binaries
CONTENTS=$(DOCS) $(MACS) $(SRCS) $(TSTS) $(OTHS)
DIRNAME=dasm-$(RELEASE)
ZIPNAME=dasm-$(RELEASE)
else
# binary release for specific platform
CONTENTS=$(BINS) $(DOCS) $(MACS) $(SRCS) $(TSTS) $(OTHS)
DIRNAME=dasm-$(RELEASE)
ZIPNAME=dasm-$(RELEASE)-$(BINARY)
endif

# create a distribution archive for publication 
dist: build
	mkdir $(DIRNAME)
	cp -p -r --parents $(CONTENTS) $(DIRNAME)
	tar cvf - $(DIRNAME) | gzip -9 >$(ZIPNAME).tar.gz
#	tar cvf - $(DIRNAME) | bzip2 -9 >$(ZIPNAME).tar.bz2
	rm -rf $(DIRNAME)

# prepare a beta release containing source code and tests;
# machine files are included since tests may need them;
# nothing else is in the archive since it is not intended
# for the public, just designated volunteers
beta:
	echo "This is an incomplete beta release of the DASM assembler." >README.BETA
	echo "The purpose is to identify regressions, nothing more." >>README.BETA
	echo "Please do *not* re-distribute this release in any form!" >>README.BETA
	echo "Please do *not* distribute binaries derived from it either!" >>README.BETA
	-tar zcvf dasm-beta-`date +%F`.tar.gz README.BETA $(MACS) $(OTHS) $(SRCS) $(TSTS)
	rm -rf README.BETA

# remove beta archives and bin/ directory created by
# regular build from this Makefile; don't delete the
# "real" distribution archives
clean:
	(cd src; $(MAKE) clean; cd ..)
	(cd test; $(MAKE) clean; cd ..)
	-rm -rf dasm-beta-*.tar.gz bin/

=== research/Makefile ===
CFLAGS=-O0 -std=c99 -Wall -Wextra # try -O3 for fun...

ALL = hash_compare compare_mod_and minunit_example get_set_progname sizeof bitsets loweror fsize #args

all: $(ALL)

clean:
	rm -rf *.o $(ALL)


MNEMONICS := $(wildcard ../src/mne*.c) ../src/globals.c

all_mnemonics.txt: $(MNEMONICS)
	cat $(MNEMONICS) | grep 'NULL,[ ]*v_' | cut -f3 -d, | sed 's/^[ ]*//g;s/"//g' | sort -u >all_mnemonics.txt

=== src/Makefile ===
--- 
+++ 
@@ -47,6 +47,15 @@
 #CFLAGS= $(GOPTI) $(GWARN) $(GDEBG)
 #LDFLAGS= -m32 -L/usr/lib32
 
+ifeq ($(OS),Windows_NT)
+      detected_OS := Windows
+else
+      detected_OS := $(shell uname -s)
+ifeq ($(detected_OS),Darwin)
+      CFLAGS = -mmacosx-version-min=10.5
+endif
+endif
+
 #CC= gcc
 
 OBJS= main.o ops.o globals.o exp.o symbols.o \
@@ -56,10 +65,11 @@
 
 ALL= dasm ftohex
 
-all: $(ALL)
+all:  $(info    detected_OS is $(detected_OS)) \
+      $(ALL)
 
 dasm: $(OBJS)
-	$(CC) $(OBJS) -o dasm $(LDFLAGS)
+	$(CC) $(CFLAGS) $(OBJS) -o dasm $(LDFLAGS)
 
 ftohex: ftohex.o

=== test/Makefile ===
# demo.asm doesn't compile!
# no useful reference output for suitef8.asm right now

DASM=../bin/dasm
FTOHEX=../bin/ftohex

test:
	./run_tests.sh -S 7 | tee test-report.txt

%.bin: %.asm
	$(DASM) $< -o$@ -f1 -DINEEPROM

%.hex: %.bin
	$(FTOHEX) 1 $< $@

clean:
	$(MAKE) -C atari2600 clean
	$(MAKE) -C atari7800 clean
	$(MAKE) -C cmdline_defs clean
	$(MAKE) -C selftest clean
	$(MAKE) -C channel-f clean
	rm -rf *.bin *.hex *.list.txt *.diff *.out

=== test/atari2600/Makefile ===

test: boing26.asm
	@../run_tests.sh -R ../../bin -F 3 -I ../../machines/atari2600/

boing26.bin: boing26.asm
	../../bin/dasm boing26.asm -f3 -I../../machines/atari2600/ -oboing26.bin

clean:
	rm -rf boing26.bin *.diff *.hex *.list.txt *.out

=== test/atari7800/Makefile ===

test: spritesample.asm
	@../run_tests.sh -R ../../bin -F 3 -I ../../machines/atari7800/

spritesample.bin: spritesample.asm
	../../bin/dasm spritesample.asm -f3 -I../../machines/atari7800/ -ospritesample.bin

clean:
	rm -rf spritesample.bin *.diff *.hex *.list.txt *.out

=== test/channel-f/Makefile ===

test: lights.asm tetris.asm
	@../run_tests.sh -R ../../bin -F 3 -I ../../machines/channel-f/

lights.bin: lights.asm
	../../bin/dasm lights.asm -f3 -I../../machines/channel-f/ -olights.bin
tetris.bin: tetris.asm
	../../bin/dasm tetris.asm -f3 -I../../machines/channel-f/ -otetris.bin

clean:
	rm -rf lights.bin tetris.bin *.diff *.hex *.list.txt *.out

=== test/cmdline_defs/Makefile ===
#
# Makefile for testing hexadecimal notation on command line args
#

DASM=../../bin/dasm
FTOHEX=../../bin/ftohex

test: 
	@../run_tests.sh -R ../../bin -D RAM_START=0x60

%.bin: %.asm
	$(DASM) $< -o$@ -f1 -T1 -s$*.sym -DRAM_START=0x60

%.hex: %.bin
	$(FTOHEX) 1 $< $@

clean:
	rm -rf *.bin *.hex *.list.txt *.diff *.sym *.out

=== test/selftest/Makefile ===
#
#  here are the tests for testing the test-script
#

DASM=../../bin/dasm
FTOHEX=../../bin/ftohex

test: 
	@../run_tests.sh -R ../../bin -S 7

%.bin: %.asm
	$(DASM) $< -o$@ -f1 

%.hex: %.bin
	$(FTOHEX) 1 $< $@

clean:
	rm -rf *.bin *.hex *.list.txt *.diff *.out

=== debian/control ===
Source: dasm
Section: otherosfs
Priority: optional
Maintainer: Joseph Nahmias <jello@debian.org>
Build-Depends:
 debhelper-compat (=13),
 latexmk,
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-extra,
Standards-Version: 4.6.1
Homepage: https://dasm-assembler.github.io/
Vcs-Browser: https://salsa.debian.org/debian/dasm
Vcs-Git: https://salsa.debian.org/debian/dasm.git
Rules-Requires-Root: no

Package: dasm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Macro assembler with support for several 8-bit microprocessors
 DASM is a versatile macro assembler with support for several 8-bit
 microprocessors including MOS 6502 & 6507; Motorola 6803, 68705, and 68HC11;
 Hitachi HD6303 (extended Motorola 6801) and Fairchild F8.
 .
 DASM boasts a number of features including:
 .
   * fast assembly
   * supports several common 8 bit processor models
   * takes as many passes as needed
   * automatic checksum generation, special symbol ’...’
   * several binary output formats available
   * allows reverse indexed origins
   * multiple segments, BSS segments (no generation), relocatable origin
   * expressions, as in C
   * 32-bit integer expressions
   * no real limitation on label size
   * complex pseudo-ops, repeat loops, macros

=== debian/watch ===
# See uscan(1) for format
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dasm-$1.tar.gz%" \
    https://github.com/dasm-assembler/dasm/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
